"use strict";
const logger_1 = require('./logger');
const builder_1 = require("./builder");
var argv = require('yargs').argv;
var glob = require("glob");
logger_1.Logger.log('Angular 2 services injection tree builder is running');
if (!argv.files) {
    logger_1.Logger.error('Target files must be specified with --files=<pattern>');
    logger_1.Logger.log('Output service list into JSON file can be done with --outputservicelistjsonfile=<path>');
    logger_1.Logger.log('Output service tree into text file can be done with --outputservicetreetextfile=<path>');
    logger_1.Logger.log('Output logs into text file can be done with --outputlogstextfile=<path>');
    process.exit();
}
logger_1.Logger.log('Reading files from pattern: ' + JSON.stringify(argv.files));
glob(argv.files, {}, (error, files) => {
    if (error) {
        logger_1.Logger.error('Error during file read: ' + error);
    }
    else if (!files || !files.length) {
        logger_1.Logger.error('No file found.');
    }
    else {
        const builder = new builder_1.DiagramBuilder(files);
        builder.build();
        builder.printServiceTree();
        if (argv.outputservicelistjsonfile) {
            builder.writeServiceListToFile(argv.outputservicelistjsonfile);
        }
        if (argv.outputservicetreetextfile) {
            builder.writeServiceTreeToFile(argv.outputservicetreetextfile);
        }
        if (argv.outputlogstextfile) {
            builder.writeLogsToFile(argv.outputlogstextfile);
        }
    }
});
//# sourceMappingURL=cli.js.map