"use strict";
class Service {
    constructor(name) {
        this._name = name;
        this.injectedServices = [];
        this.injectionServices = [];
    }
    get name() { return this._name; }
    getSize() {
        return this.getInjectionSize([]);
    }
    getInjectionSize(parents) {
        let size = 0;
        if (this.injectionServices) {
            size = this.injectionServices.length;
            this.injectionServices.filter(s => !parents.some(p => s.name === p.name)).forEach(injectionService => {
                let newParents = [this];
                parents.forEach(p => newParents.push(p));
                size += injectionService.getInjectionSize(newParents);
            });
        }
        return size;
    }
}
exports.Service = Service;
//# sourceMappingURL=service.js.map