
export class Service
{
  private _name:string;

  injectedServices:Service[];
  injectionServices:Service[];

  constructor(name:string)
  {
    this._name = name;

    this.injectedServices = [];
    this.injectionServices = [];
  }

  public get name():string { return this._name; }

  getSize():number
  {
    return this.getInjectionSize([]);
  }

  private getInjectionSize(parents:Service[])
  {
    let size = 0;

    if(this.injectionServices)
    {
      size = this.injectionServices.length;

      this.injectionServices.filter(s => !parents.some(p => s.name === p.name)).forEach(injectionService =>
      {
        let newParents:Service[] = [this];

        parents.forEach(p => newParents.push(p));

        size += injectionService.getInjectionSize(newParents);
      });
    }

    return size;
  }
}
